function updateEnemies()
	for i, enemy in pairs(enemies) do
		--set enemy stats
		if not enemy.hasStats then
			if enemy.id == 1 then
				enemy.speed = 190 + (player.enemyFerocity - 1) * 80
				enemy.health = 35
				enemy.name = "grunt"
				enemy.color = {215,45,45}
				enemy.behaviour = "chase"
			end
			if enemy.id == 2 then
				enemy.speed = 130
				enemy.health = 50
				enemy.timer = math.random(-50,50) / 100
				enemy.name = "spectre"
				enemy.color = {20,160,205}
				enemy.behaviour = "random"
			end
			if enemy.id == 3 then
				enemy.speed = 200
				enemy.health = 40
				enemy.timer = math.random(-20,20)/100
				enemy.name = "archer"
				enemy.color = {255,170,50}
				enemy.behaviour = "random"
			end
			if enemy.id == 4 then
				enemy.speed = 175
				enemy.health = 35
				enemy.timer = 0
				enemy.name = "sprinkler"
				enemy.color = {255,230,90}
				enemy.behaviour = "random"
			end
			if enemy.id == 5 then
				enemy.speed = 210
				enemy.health = 50
				enemy.timer = math.random(-20,20)/100
				enemy.name = "hunter"
				enemy.color = {230,80,120}
				enemy.behaviour = "random"
			end
			if enemy.id == 6 then
				enemy.speed = player.speed*1.15
				enemy.health = 3300
				enemy.timer = 0
				enemy.count = 0
				enemy.particleTimer = 0
				enemy.name = "poltergeist"
				enemy.color = {219,244,255}
				enemy.behaviour = "chase"
			end
			if enemy.id == 7 then
				enemy.speed = 150
				enemy.health = 35
				enemy.timer = math.random(-30,30)/100
				enemy.name = "summoner"
				enemy.color = {180,35,110}
				enemy.behaviour = "random"
			end
			if enemy.id == 8 then
				enemy.speed = 400
				enemy.health = 17.5
				enemy.name = "ghoul"
				enemy.color = {160,65,215}
				enemy.behaviour = "chase"
			end
			
			enemy.maxHealth = enemy.health
			enemy.hasStats = true
		end
		
		--set enemy id
		if enemy.ids == nil then
			enemy.ids = math.random(1,1000000)
		end
		
		--poison timer
		if enemy.poisonTimer == nil then
			enemy.poisonTimer = 0
		end
		
		--freeze
		enemy.freeze = enemy.freeze or 0
		if enemy.id == 6 then
			enemy.freeze = math.min(math.max(enemy.freeze - (180*hdt), 0), 100)
		else
			enemy.freeze = math.max(enemy.freeze - (30*hdt), 0)
		end
		
		--update enemy.hit stuff
		if enemy.hit == nil or enemy.hit < 0 then
			enemy.hit = 0
		end
		enemy.hit = enemy.hit - (6*hdt)
		
		
		--move enemies
		enemy.px = enemy.x
		enemy.py = enemy.y
		local speed = math.max((enemy.speed - enemy.freeze), 0)
		
		if enemy.x > border.x + border.width or enemy.x < border.x - border.width or enemy.y > border.y + border.height or enemy.y < border.y - border.height then
			enemy.x = enemy.x - (((enemy.x - player.x) * hdt)/getDistance(player.x,player.y,enemy.x,enemy.y)*speed)
			enemy.y = enemy.y - (((enemy.y - player.y) * hdt)/getDistance(player.x,player.y,enemy.x,enemy.y)*speed)
		else
			if enemy.behaviour == "chase" then
				enemy.x = enemy.x - (((enemy.x - player.x) * hdt)/getDistance(player.x,player.y,enemy.x,enemy.y)*speed)
				enemy.y = enemy.y - (((enemy.y - player.y) * hdt)/getDistance(player.x,player.y,enemy.x,enemy.y)*speed)
			end
			if enemy.behaviour == "random" then
				enemy.reTargetTimer = enemy.reTargetTimer or 0
				if enemy.targetX == nil or enemy.reTargetTimer > 0.8 then
					enemy.targetX = math.random(-border.width, border.width)
					enemy.targetY = math.random(-border.height, border.height)
					
					enemy.reTargetTimer = math.random(-5,5)/10
				end
				
				enemy.reTargetTimer = enemy.reTargetTimer + hdt
				
				local a = math.angle(enemy.x,enemy.y, enemy.targetX + border.x,enemy.targetY + border.y)
				enemy.x = enemy.x + math.cos(a)*speed*hdt
				enemy.y = enemy.y + math.sin(a)*speed*hdt
			end
		end
		
		--collision with other enemies/player
		for j, enemy2 in pairs(enemies) do
			if enemy.id ~= 6 and enemy.id ~= 8 and i ~= j then
				if getDistance(enemy.x,enemy.y,enemy2.x,enemy2.y) < 40 or getDistance(enemy.x,enemy.y,player.x,player.y) < 40 then
					enemy.x = enemy.px
					enemy.y = enemy.py
				end
			end
		end
		
		--spectre/poltergeist collision
		for j, enemy2 in pairs(enemies) do
			if i ~= j then
				if enemy.id == 2 and enemy2.id == 2 or enemy.id == 6 and enemy2.id == 6 or enemy.id == 8 and enemy2.id == 8 then
					if getDistance(enemy.x,enemy.y,enemy2.x,enemy2.y) < 40 or getDistance(enemy.x,enemy.y,player.x,player.y) < 40 then
						enemy.x = enemy.px
						enemy.y = enemy.py
					end
				end
			end
		end
		
		--collision with bullets
		for j, bullet in pairs(bullets) do
			if bullet.friendly then
				if getDistance(bullet.x,bullet.y,enemy.x,enemy.y) < 30 or bullet.px and getDistance(bullet.x * 0.5 + bullet.px * 0.5,bullet.y * 0.5 + bullet.py * 0.5,enemy.x,enemy.y) < 30 or bullet.px 
				and getDistance(bullet.x * 0.75 + bullet.px * 0.25,bullet.y * 0.75 + bullet.py * 0.25,enemy.x,enemy.y) < 30 or bullet.px and getDistance(bullet.x * 0.25 + bullet.px * 0.75,bullet.y * 0.25 + bullet.py * 0.75,enemy.x,enemy.y) < 30 then
					screen:shake(21)
					screen:zoom(0.99)
					
					spark(4,bullet.x,bullet.y,400,1,0.2,30,enemy.color, 0.25)
					spark(1,bullet.x,bullet.y,400,1,0.2,30,enemy.color, 12)
					
					a_hit:setVolume(0.7)
					a_hit:setPitch((1 - (enemy.health / enemy.maxHealth)) * 0.8 + 0.9)
					la.play(a_hit:clone())
					table.remove(bullets, j)
					if menu.character == 4 and player.armor > 1 then		--set extra damage for blacksmith
						enemy.health = enemy.health - (bullet.damage*2)
					elseif bullet.timer and bullet.timer < bullet.maxTimer and menu.character == 3 then
						if bullet.noEnergy and enemy.id == 6 then
							enemy.health = enemy.health - bullet.damage * 0.5
						else
							enemy.health = enemy.health - bullet.damage * 2
						end
					else
						if bullet.noEnergy and enemy.id == 6 then
							enemy.health = enemy.health - bullet.damage * 0.3
						else
							enemy.health = enemy.health - bullet.damage
						end
					end
					enemy.poisonTimer = weapon.poisonTime
					enemy.freeze = enemy.freeze + weapon.freeze
					enemy.hit = 1
					
					if not bullet.noEnergy then weapon.energy = math.min(weapon.maxEnergy, weapon.energy + (weapon.energyGain * 0.005 * weapon.damage / 12.5)) end
				end
			end
		end
		
		--kill enemy
		if enemy.health < 0.1 then
			screen:shake(40)
			screen:zoom(0.85)
			lt.sleep(1/60)
			unlocks.killCount = unlocks.killCount + 1
			
			a_enemyDeath:setPitch(math.random(75,125)/100)
			a_enemyDeath:setVolume(1)
			la.play(a_enemyDeath:clone())
			
			spark(4,enemy.x,enemy.y,0,1,0.5,1,enemy.color, 2)
			spark(4,enemy.x,enemy.y,700,1,0.3,20,enemy.color, 0.5)
			spark(1,enemy.x,enemy.y,700,1,0.3,20,enemy.color, 25)
			spark(1,enemy.x,enemy.y,0,1,0.25,1,enemy.color, 50)
			
			
			if enemy.poisonTimer > 0 and enemy.hit < 0.5 then
				spark(3,enemy.x,enemy.y,10,3,0.4,3,"n/a")
			end
			
			table.remove(enemies, i)
		end
		
		
		--damage player
		local meleeInterval = 0.25
		enemy.meleeTimer = enemy.meleeTimer or 0
		enemy.meleeTimer = enemy.meleeTimer + hdt
		if enemy.meleeTimer > meleeInterval then
			enemy.meleeTimer = enemy.meleeTimer - meleeInterval
			if enemy.id == 1 then
				if getDistance(player.x,player.y,enemy.x,enemy.y) < 45 then
					hurtPlayer(15*meleeInterval)
				end
			end
			if enemy.id == 7 then
				if getDistance(player.x,player.y,enemy.x,enemy.y) < 45 then
					hurtPlayer(5*meleeInterval)
				end
			end
			if enemy.id == 8 then
				if getDistance(player.x,player.y,enemy.x,enemy.y) < 45 then
					hurtPlayer(7*meleeInterval)
				end
			end
		end
		
		--poison damage
		if enemy.poisonTimer > 0 then
			enemy.health = enemy.health - (10*hdt)
			enemy.poisonTimer = enemy.poisonTimer - hdt
		end
		
		--enemies shooting
		if enemy.id == 2  then
			if enemy.timer > 4.5 then
				enemy.timer = math.random(-0.7,0.7)
				
				for a=0, math.rad(360-45), math.rad(45) do
					newBullet = {x = enemy.x, y = enemy.y, xdir = math.cos(a), ydir = math.sin(a), speed = 320, damage = 4.5, friendly = false, color = "blue"} table.insert(bullets,newBullet)
				end
			else
				enemy.timer = enemy.timer + hdt * player.enemyFerocity
			end
		end
		
		if enemy.id == 3 and enemy.timer > 1.7 then
			enemy.timer = 0
			xd = -((enemy.x - player.x) / getDistance(enemy.x,enemy.y,player.x,player.y))
			yd = -((enemy.y - player.y) / getDistance(enemy.x,enemy.y,player.x,player.y))
			
			newBullet = {x = enemy.x, y = enemy.y, xdir = xd, ydir = yd, speed = 600, damage = 8, friendly = false, color = "orange"} table.insert(bullets,newBullet)
		elseif enemy.id == 3 then
			enemy.timer = enemy.timer + hdt * player.enemyFerocity
		end
		
		if enemy.id == 4 and enemy.timer > 3.6 then
			enemy.timer = 0
			
			newBullet = {x = enemy.x, y = enemy.y, xdir = 1, ydir = 0, speed = 1600, damage = 11, friendly = false, color = "yellow"} table.insert(bullets,newBullet)
			newBullet = {x = enemy.x, y = enemy.y, xdir = -1, ydir = 0, speed = 1600, damage = 11, friendly = false, color = "yellow"} table.insert(bullets,newBullet)
			newBullet = {x = enemy.x, y = enemy.y, xdir = 0, ydir = 1, speed = 1600, damage = 11, friendly = false, color = "yellow"} table.insert(bullets,newBullet)
			newBullet = {x = enemy.x, y = enemy.y, xdir = 0, ydir = -1, speed = 1600, damage = 11, friendly = false, color = "yellow"} table.insert(bullets,newBullet)
		elseif enemy.id == 4 then
			enemy.timer = enemy.timer + hdt * player.enemyFerocity
			enemy.iminentAttack = enemy.timer > 3.3
		end
		
		if enemy.id == 5 and enemy.timer > 4.7 then
			enemy.timer = 0
			xd = -((enemy.x - player.x) / getDistance(enemy.x,enemy.y,player.x,player.y))
			yd = -((enemy.y - player.y) / getDistance(enemy.x,enemy.y,player.x,player.y))
			
			newBullet = {x = enemy.x, y = enemy.y, xdir = xd, ydir = yd, speed = 20, damage = 6, friendly = false, color = "pink", homing = true} table.insert(bullets,newBullet)
		elseif enemy.id == 5 then
			enemy.timer = enemy.timer + hdt * player.enemyFerocity
		end
		
		if enemy.id == 6 and enemy.timer > 4 then
			enemy.speed = 25
			enemy.timer = 3.6
			enemy.count = enemy.count + 1
			
			for a=0, math.rad(360-45), math.rad(45) do
				newBullet = {x = enemy.x, y = enemy.y, xdir = math.cos(a+lt.getTime()*0.5), ydir = math.sin(a+lt.getTime()*0.5), speed = 900, damage = 3, friendly = false, color = "white"} table.insert(bullets,newBullet)
			end
			
			if enemy.count % 5 == 0 then
				newBullet = {x = enemy.x, y = enemy.y, xdir = -1, ydir = 0, speed = 25, damage = 3.5, friendly = false, homing = true, color = "grey"} table.insert(bullets,newBullet)
				newBullet = {x = enemy.x, y = enemy.y, xdir = 1, ydir = 0, speed = 25, damage = 3.5, friendly = false, homing = true, color = "grey"} table.insert(bullets,newBullet)
			end
		elseif enemy.id == 6 and enemy.count > 12 then
			enemy.timer = 0
			enemy.count = 0
			enemy.speed = 250
			if enemy.behaviour == "chase" then
				enemy.behaviour = "random"
			else
				enemy.behaviour = "chase"
			end
		end
		if enemy.id == 6 then
			enemy.timer = enemy.timer + hdt * player.enemyFerocity
		end
		
		--summoning
		if enemy.id == 7 and enemy.timer > 6 and getDistance(enemy.x,enemy.y,player.x,player.y) < 2200 and getGhoulCount() < 20 and getClosestEnemyDist(enemy.x,enemy.y) > 40 then
			enemy.timer = 0
			
			newEnemy = {x = enemy.x, y = enemy.y, id = 8, ids = enemy.ids, freeze = 0, hit = 0, color = {0,0,0}, poisonTimer=0, health = 1, maxHealth = 1, speed = 1, behaviour = 'chase'} table.insert(enemies,newEnemy)
		elseif enemy.id == 7 then
			enemy.timer = enemy.timer + hdt * player.enemyFerocity
		end
		
		
		--remove enemies when outside of borders for too long
		if enemy.x > border.x + border.width or enemy.x < border.x - border.width or enemy.y > border.y + border.height or enemy.y < border.y - border.height then
			if enemy.deathTimer == nil then
				enemy.deathTimer = 25
			end
			enemy.deathTimer = enemy.deathTimer - hdt
			if enemy.deathTimer < 0 then
				table.remove(enemies,i)
			end
		end
		
		--remove enemies that are stuck in eachother
		for j, enemy2 in pairs(enemies) do
			if enemy.x > border.x + border.width or enemy.x < border.x - border.width or enemy.y > border.y + border.height or enemy.y < border.y - border.height then
				if getDistance(enemy.x,enemy.y,enemy2.x,enemy2.y) < 38 and i ~= j then
					table.remove(enemies,i)
				end
			end
		end
		
	end
end

function getClosestEnemyDist(x,y)
	local dist = getDistance(x,y, enemies[1].x,enemies[1].y)
	for i = 2, #enemies do
		local e = enemies[i]
		local newDist = getDistance(e.x,e.y, x,y)
		if newDist < dist and newDist > 0.1 then
			dist = newDist
		end
	end
	
	return dist
end
