function loadFunctions()
	function getDistance(x1,y1,x2,y2)
		return ((x2-x1)^2+(y2-y1)^2)^0.5 
	end
	
	function math.angle(x1,y1, x2,y2)
		return math.atan2(y2-y1, x2-x1)
	end
	
	function summon(enemyId, count)
		count = count * 2
		while count > 0 do
			count = count - 1
			local a = math.rad(math.random(0,36000)/100)
			local dist = border.width + 640 + 20
			newEnemy = {x = border.x + math.cos(a) * dist, y = border.y + math.sin(a) * dist, id = enemyId, ids = math.random(1,1000000), freeze = 0, hit = 0, color = {0,0,0}, poisonTimer=0, health = 1, maxHealth = 1, speed = 1, behaviour = 'chase'} 
			
			table.insert(summonList,newEnemy)
		end
	end
	
	function updateCardRandom()
		cardRandom = {first = math.random(1,9), second = math.random(1,9), third = math.random(1,9)}
		while cardRandom.first == cardRandom.second or cardRandom.first == cardRandom.third or cardRandom.second == cardRandom.third do
			cardRandom = {first = math.random(1,9), second = math.random(1,9), third = math.random(1,9)}
		end
	end
	
	function updateAudioRandom()
		if wave.current == 10 or wave.current == 20 then
			audioRandom.combat = 0
		elseif wave.current > 0 then
			audioRandom.combat = math.random(1,6) 
		else
			audioRandom.combat = -1
		end
	end
	
	function spark(id1,x1,y1,speed1,dir,timer1,count,color1, size, chromAbb, minSpeed)
		size = size or 1
		chromAbb = chromAbb or 0
		while count > 0 do
			local s = speed1
			if dir == 1 then
				minSpeed = minSpeed or 0.4
				local a = math.rad(math.random(0,360))
				xdir1 = math.cos(a)
				ydir1 = math.sin(a)
				s = s * (math.random(100,minSpeed*100)/100)
			elseif dir == 2 then
				xdir1 = x1 - player.x / getDistance(x1,y1,player.x,player.y)
				ydir1 = y1 - player.y / getDistance(x1,y1,player.x,player.y)
			elseif dir == 3 then
				xdir1 = 0
				ydir1 = -1
			elseif dir[1] == 1 then
				local a = dir[2] + math.rad(math.random(-dir[3] / 2 * 100, dir[3] / 2 * 100) / 100)
				xdir1 = math.cos(a)
				ydir1 = math.sin(a)
				s = s * (math.random(100,minSpeed*100)/100)
			end
			count = count - 1
			newParticle = {id = id1, x = x1, y = y1 , speed = s, xdir = xdir1, ydir = ydir1, timer = timer1, color = color1, size = size, chromAbb = chromAbb} table.insert(particles,newParticle)
		end
	end
	
	function playS(sound)
		love.audio.stop(sound)
		love.audio.play(sound)
	end
	
	function getEnemyCount()
		local n = 0
		for i, enemy in pairs(enemies) do
			n = n + 1
		end
		return n
	end
	
	function getGhoulCount()
		local n = 0
		for i, enemy in pairs(enemies) do
			if enemy.id == 8 then
				n = n + 1
			end
		end
		return n
	end
	
	function alignbgTiles()
		for i, tile in pairs(bgTiles) do
			tile.x = math.floor(tile.x/40)*40
			tile.y = math.floor(tile.y/40)*40
		end
			border.x = math.floor(border.x/40)*40
			border.y = math.floor(border.y/40)*40
	end
	
	function playerInBorder()
		while player.x > border.x+border.width do
			for i, tile in pairs(bgTiles) do
				tile.x = tile.x + 40
			end
		end
			border.x = border.x + 40
		while player.x < border.x-border.width do
			while player.x < border.x-border.width do
				for i, tile in pairs(bgTiles) do
					tile.x = tile.x - 40
				end
			end
				border.x = border.x - 40
		end
		while player.y < border.y-border.height do
			while player.y > border.y+border.height do
				for i, tile in pairs(bgTiles) do
					tile.y = tile.y - 40
				end
			end
				border.y = border.y - 40
		end
		while player.y > border.y+border.height do
			while player.y < border.y-border.height do
				for i, tile in pairs(bgTiles) do
					tile.y = tile.y + 40
				end
			end
				border.y = border.y + 40
		end
	end
	
	function setColor(r,g,b,a)
		a = a or 255
		if not b then
			g = g or 255
			lg.setColor(r[1]/255,r[2]/255,r[3]/255,g/255)
		else
			lg.setColor(r/255,g/255,b/255,a/255)
		end
	end
	
end