function updateInput()
	player.ydir = 0
	player.xdir = 0

	--set player dir
	if not inMenu then
		if love.keyboard.isDown('w') and col.blockUp == false then
			player.ydir = -player.speed
		end
		
		if love.keyboard.isDown('s') and col.blockDown == false then
			player.ydir = player.speed
		end
		
		if love.keyboard.isDown('a') and col.blockLeft == false then
			player.xdir = -player.speed
		end
		
		if love.keyboard.isDown('d') and col.blockRight == false then
			player.xdir = player.speed
		end
		
	--move player
		if love.keyboard.isDown('w','a','s','d') and inMenu == false then
			for i, enemy in pairs(enemies) do
				enemy.x = enemy.x - (player.xdir*hdt)
				enemy.y = enemy.y - (player.ydir*hdt)
			end
			for i, bullet in pairs(bullets) do
				bullet.x = bullet.x - (player.xdir*hdt)
				bullet.y = bullet.y - (player.ydir*hdt)
			end
			for i, particle in pairs(particles) do
				particle.x = particle.x - (player.xdir*hdt)
				particle.y = particle.y - (player.ydir*hdt)
			end
			for i, bgTile in pairs(bgTiles) do
				bgTile.x = bgTile.x - (player.xdir*hdt)
				bgTile.y = bgTile.y - (player.ydir*hdt)
			end
			for i, t in pairs(turrets) do
				t.x = t.x - (player.xdir*hdt)
				t.y = t.y - (player.ydir*hdt)
			end
			border.x = border.x - (player.xdir*hdt)
			border.y = border.y - (player.ydir*hdt)
		end
		
	--shooting
		xd = -((player.x - mouse.x) / getDistance(player.x,player.y,mouse.x,mouse.y))
		yd = -((player.y - mouse.y) / getDistance(player.x,player.y,mouse.x,mouse.y))
		if menu.character == 5 and player.health <= player.maxHealth * 0.25 then
			weapon.timer = math.min(weapon.timer + hdt * 2, weapon.maxTimer)
		else
			weapon.timer = math.min(weapon.timer + hdt, weapon.maxTimer)
		end
		
		if love.mouse.isDown(1) and player.health > 0 then
			if weapon.timer >= weapon.maxTimer then
				weapon.timer = weapon.timer - weapon.maxTimer
				local angle = math.angle(player.x,player.y, mouse.x,mouse.y)
				local dist = 12
				spark(1, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.15,1, "green", 190)
				spark(4, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.15,1, {115,255,115}, 1.05)
				newBullet = {x = player.x + math.cos(angle)*dist, y = player.y + math.sin(angle)*dist, xdir = xd, ydir = yd, speed = weapon.speed, damage = weapon.damage, friendly = true, color = "green"} table.insert(bullets,newBullet)
				if inMenu then else
					a_shoot:setPitch(math.random(75,125)/100)
					la.play(a_shoot:clone())
					
					screen:shake(7)
				end
			end
		end
	end
	
--activating cards
	for i, card in pairs(cards) do
		if mouse.x > card.x and mouse.x < card.x + 200 and mouse.y > card.y and mouse.y < card.y + 200 then --hover check
			if card.hover == false then
				playS(a_cardselect)
			end
			card.hover = true
			if love.mouse.isDown('1') and audioController.combatVolume == 0 then --click lmb and audio-is-low check
				if card.id == 0 then --reroll
					cards = {}
					updateCardRandom()
					newCard = {x = 1280/2-500, y = 300, id = cardRandom.first} table.insert(cards,newCard)
					newCard = {x = 1280/2+300, y = 300, id = cardRandom.second} table.insert(cards,newCard)
					
				elseif card.id == 1 then --health boost
					if menu.character == 4 then
						player.maxHealth = player.maxHealth + 7
					else
						player.maxHealth = player.maxHealth + 14
					end
					cardLevel.health = cardLevel.health + 1
				elseif card.id == 2 then --speed boost
					player.defSpeed = player.defSpeed + 40
					cardLevel.speed = cardLevel.speed + 1
				elseif card.id == 3 then --damage boost
					weapon.damage = weapon.damage + 2.5
					cardLevel.damage = cardLevel.damage + 1
				elseif card.id == 4 then --border increase
					border.width = border.width + 80
					border.height = border.height + 40
					cardLevel.border = cardLevel.border + 1
				elseif card.id == 5 then --firerate increase
					weapon.maxTimer = weapon.maxTimer / 1.08
					cardLevel.firerate = cardLevel.firerate + 1
				elseif card.id == 6 then --bullet speed boost
					weapon.freeze = weapon.freeze + 30
					cardLevel.freeze = cardLevel.freeze + 1
				elseif card.id == 7 then --poison enable/boost
					weapon.poisonTime = weapon.poisonTime + 1.5
					cardLevel.poison = cardLevel.poison + 1
				elseif card.id == 8 then --gain armor
					player.armor = player.armor + 80
					cardLevel.armor = cardLevel.armor + 1
				elseif card.id == 9 then --gain energy
					weapon.maxEnergy = weapon.maxEnergy + 0.15
					weapon.energyGain = weapon.energyGain + 0.2
					cardLevel.energy = cardLevel.energy + 1
				end
				
				if card.id == 0 then else
					audioRandom.change = true
					playS(a_carduse)
					player.health = player.maxHealth
					cards = {}
					wave.alpha = 1000
					
					for j, t in pairs(turrets) do
						t.deathTimer = 1
					end
				end
			end
		else	
			card.hover = false
		end
	end
	
	--gameover screen to main menu
	if love.keyboard.isDown('space') and gameover.redAlpha > 255*0.1 and player.health < 1 then
		menu.isDown = true
		inMenu = true
		player.health = 100
		audioRandom.change = true
		gameover.redAlpha = -1000
		love.audio.stop(a_musicCombat)
		la.play(a_musicMenu)
		audioRandom.combat = 99
	end
	
--quit
	if love.keyboard.isDown('escape') then
		love.event.quit()
	end
	
--change fullscreen
	if love.keyboard.isDown('f') and options.press then
		options.press = false
		if options.fullscreen then
			options.fullscreen = false
			love.window.setFullscreen(false)
		else
			options.fullscreen = true
			love.window.setFullscreen(true)
		end
		
	end

--set showfps stuff
	if love.keyboard.isDown('z') and options.press then
		options.press = false
		if options.showFps then
			options.showFps = false
		else
			options.showFps = true
		end
	end
	
	if love.keyboard.isDown('z','f') then else
		options.press = true
	end
	
--change master volume
	if love.keyboard.isDown('+') then
		options.volume = options.volume + (1/3*hdt)
		if options.volume > 1 then
			options.volume = 1
		end
	end
	if love.keyboard.isDown('-') then
		options.volume = options.volume - (1/3*hdt)
		if options.volume < 0 then
			options.volume = 0
		end
	end
	
	
--instakill/speedbost cheat
	if love.keyboard.isDown('p') and love.keyboard.isDown('i') and love.keyboard.isDown('3') then
		player.speed = 350
	--	player.health = 9999
	--	player.maxHealth = 9999
		player.armor = 9999
		weapon.maxTimer = 0.1
		weapon.damage = 9999
		weapon.speed = 1500
	end
	
--demo cheat
	if love.keyboard.isDown('l') and love.keyboard.isDown('i') and love.keyboard.isDown('3') then
		player.speed = 400
	--	player.health = 9999
	--	player.maxHealth = 9999
		weapon.maxTimer = 0.13
		weapon.damage = 20
		weapon.speed = 850
	end
	
--slow motion cheat
	if lk.isDown('1') and lk.isDown("c") and lk.isDown("3") then
		options.hdtMult = 0.1
	end

end