function updateMenu()
	if inMenu then
		--add buttons
		if buttons[1] == nil then
			a_back:setVolume(0)
			menu_main()
			a_back:setVolume(1)
		end
		
		--interact with buttons
		for i, b in pairs(buttons) do
			b.hover = false
			if mouse.x > b.x and mouse.x < b.x + b.w and mouse.y > b.y and mouse.y < b.y + b.h then
				b.hover = true
				
				if primaryPressed then
					b.func()
				end
			end
		end
		
		if primaryPressed then
			primaryPressed = false
		end
		
		--interact with sliders
		for i, s in pairs(sliders) do
			s.setting = s.setting or 0.5
			s.hover = false
			if mouse.x > s.x and mouse.x < s.x + s.w and mouse.y > s.y and mouse.y < s.y + s.h then
				s.hover = true
				
				if lm.isDown(1) then
					s.setting = (mouse.x - s.x) / s.w
					s.func(s.setting)
				end
			end
		end
		
		--set vals
		unlocks.killCount = 0
		cards = {}
		bullet = {}
		enemies = {}
	
	end
end

function menu_settings()
	menu.view = "settings"
	buttons = {}
	sliders = {}
	table.insert(buttons, {x=0, y=75, w=500, h=100, func = menu_main, text = "Back"})
	table.insert(buttons, {x=0, y=200, w=350, h=40, func = menu_fullscreen, text = "Fullscreen"})
	table.insert(sliders, {x=30, y=325, w=300, h=40, func = menu_audio, text = "Audio volume"})
	table.insert(sliders, {x=30, y=430, w=300, h=40, func = menu_screenEffect, text = "Screen shake intensity"})
	table.insert(sliders, {x=30, y=535, w=300, h=40, func = menu_screenShatter, text = "Screen shatter intensity"})
	la.play(a_select:clone())
end

function menu_main()
	menu.view = "main"
	buttons = {}
	sliders = {}
	primaryPressed = false
	table.insert(buttons, {x=0, y=75, w=500, h=100, func = menu_play, text = "Play"})
	table.insert(buttons, {x=0, y=200, w=350, h=40, func = menu_settings, text = "Settings"})
	table.insert(buttons, {x=0, y=265, w=350, h=40, func = menu_quit, text = "Quit"})
	
	table.insert(buttons, {x=1280-180, y=115, w=50, h=75, func = menu_nextChar, text = "", style = 'playerSelect', icon = 'right'})
	table.insert(buttons, {x=1280-440, y=115, w=50, h=75, func = menu_prevChar, text = "", style = 'playerSelect', icon = 'left'})
	la.play(a_back:clone())
end

function menu_nextChar()
	menu.character = menu.character + 1
	
	while menu.character == 1 or menu.character == 2 do
		menu.character = menu.character + 1
	end
		
	if menu.character > 6 then
		menu.character = 0
	end
	
	la.play(a_select:clone())
end

function menu_prevChar()
	menu.character = menu.character - 1
	
	if menu.character < 0 then
		menu.character = 6
	end
				
	while menu.character == 1 or menu.character == 2 do
		menu.character = menu.character - 1
	end
	
	la.play(a_select:clone())
end

function menu_quit()
	love.event.quit()
end

function menu_screenShatter(s)
	options.shatterIntensity = s
end

function menu_screenEffect(s)
	options.shakeIntensity = s
	options.zoomIntensity = s
end

function menu_audio(s)
	options.volume = s
end

function menu_fullscreen()
	love.window.setFullscreen(not love.window.getFullscreen())
	la.play(a_select:clone())
end

function menu_play()
	if menu.character == 0 or menu.character == 3 and unlocks.smuggler == 1 or menu.character == 4 and unlocks.blacksmith == 1 or menu.character == 5 and unlocks.berserker == 1 or menu.character == 6 and unlocks.gambler == 1 then
		inMenu = false
		la.play(a_start:clone())
		
		if unlocks.tutorial == 0 then
			wave.current = -3
			wave.timer = 1
		else
			wave.current = 1
			wave.timer = 4
		end
		
		la.stop(a_musicMenu)
			
		wave.timer = 0
		wave.displayCards = false
		wave.alpha = 1000
		cards = {}
		enemies = {}
		bullets = {}
		audioController.combatVolume = 0
		gameover.redAlpha = 0
		audioRandom.change = true
		cardLevel = {speed = 0, health = 0, damage = 0, firerate = 0, armor = 0, poison = 0, border = 0, freeze = 0, energy = 0}
		border = {x = 1280/2, y = 720/2, width = 440, height = 240}
		weapon.poisonTime = 0
		weapon.freeze = 0
		weapon.energy = 1
		weapon.maxEnergy=1
		weapon.energyGain=1
		player.x = 1280/2
		player.y = 720/2
		alignbgTiles()
		playerInBorder()
		
		playS(a_musicCombat)
		local fireRateMult = 0.85
		local speedMult = 4
		local playerSpeedMult = 1.3
		
		if menu.character == 0 then		--player stats for different characters  --knight
			player.speed = 250 * playerSpeedMult
			player.health = 110
			player.maxHealth = 110
			player.armor = 0
			player.enemyFerocity = 0.9
			weapon.damage = 15 * fireRateMult
			weapon.speed = 650 * speedMult
			weapon.maxTimer = 0.17 * fireRateMult
			weapon.special = sa_beam
		end
		
		if menu.character == 1 then		--Brute !dep!
		end
		if menu.character == 2 then		--Rogue !dep!
		end
		
		if menu.character == 3 then		--Smuggler
			player.speed = 250 * playerSpeedMult
			player.health = 80
			player.maxHealth = 80
			player.armor = 0
			player.enemyFerocity = 1.3
			weapon.damage = 7 * fireRateMult
			weapon.speed = 550 * speedMult
			weapon.maxTimer = 0.14 * fireRateMult
			weapon.special = sa_piercingShot
		end
		if menu.character == 4 then		--Blacksmith
			player.speed = 250 * playerSpeedMult
			player.health = 35
			player.maxHealth = 35
			player.armor = 10
			player.enemyFerocity = 1.45
			weapon.damage = 22.5 * fireRateMult
			weapon.speed = 700 * speedMult
			weapon.maxTimer = 0.45 * fireRateMult
			weapon.special = sa_stim
		end
		if menu.character == 5 then		--Berserker
			player.speed = 210 * playerSpeedMult
			player.health = 100
			player.maxHealth = 100
			player.armor = 0
			player.enemyFerocity = 1.75
			weapon.damage = 16 * fireRateMult
			weapon.speed = 550 * speedMult
			weapon.maxTimer = 0.27 * fireRateMult
			weapon.special = sa_clear
		end
		if menu.character == 6 then		--Gambler
			player.speed = 265 * playerSpeedMult
			player.health = 80
			player.maxHealth = 80
			player.armor = 0
			player.enemyFerocity = 2.3
			weapon.damage = 12 * fireRateMult
			weapon.speed = 550 * speedMult
			weapon.maxTimer = 0.2 * fireRateMult
			weapon.special = sa_turret
		end
		player.defSpeed = player.speed
	end
end