function updatePlayer()
	player.hurt = math.max(player.hurt - hdt*0.3, 0)
	
	if not inMenu then
		player.speed = player.defSpeed
		weapon.special()

		--check borders
		col = {blockUp = false, blockDown = false, blockLeft = false, blockRight = false}
		if player.x + 20 > border.x + border.width then
			col.blockRight = true
		end
		if player.x - 20 < border.x - border.width then
			col.blockLeft = true
		end
		if player.y - 20 < border.y - border.height then
			col.blockUp = true
		end
		if player.y + 20 > border.y + border.height then
			col.blockDown = true
		end
		
		--check bullet collision
		for i, bullet in pairs(bullets) do
			if bullet.friendly == false and getDistance(bullet.x,bullet.y,player.x,player.y) < 26 then
				table.remove(bullets,i)
				hurtPlayer(bullet.damage)
			end
		end
		
		--health to armor conversion
		while player.health < player.maxHealth and player.armor > 0 do
			player.armor = player.armor - 0.1
			player.health = player.health + 0.1
		end

		
		--cap armor
		if player.armor > player.maxHealth then
			player.armor = player.maxHealth
		end
		
		--Knight health regen
		if menu.character == 0 and player.health < player.maxHealth*0.3 then
			player.health = player.health + (2.3*hdt)
		end
		
		--Berserker speed increase
		if menu.character == 5 and player.health < player.maxHealth*0.25 then
			player.speed = player.defSpeed * 1.5
		end
		
		--lock mouse to screen if in fullscreen
		if mouse.x > 1280 then
			mouse.x = 1280
		end
		if mouse.y > 720 then
			mouse.y = 720
		end
		
		--gameover stuff
		if player.health < 1 then
			player.speed = 0
			player.health = 0
			for i, bullet in pairs(bullets) do
				if bullet.friendly then
					table.remove(bullets,i)
				end
			end
			if gameover.redAlpha >= 255 then
				enemies = {}
				bullets = {}
				turrets = {}
			end
		end
	end
	
	--update glitch effect
	if player.hurt <= 0 then
		glitchObjects = {}
	end
end

function hurtPlayer(dmg)
	if player.health > 0 then
		player.health = math.max(0, player.health - dmg)
		screen:rotate(math.rad(dmg * 4.5))
		player.hurt = 1
		
		a_hit2:setPitch(1.1 - (player.health / player.maxHealth * 0.3))
		a_hit2:setVolume(1)
		la.play(a_hit2:clone())
		
		for i=math.floor(dmg * 0.5), 0, -1 do
			local rot = math.rad(math.random(0, 360))
			local subt = math.random(1,2) == 1
			table.insert(glitchObjects, {img = getGlitchImg(), x = math.random(0,1280), y = math.random(0,720), s = 0.5, r = rot, red = math.random(1,10)/100, green = math.random(1,10)/100, subtract = subt})
		end
	end
end

function getGlitchImg()
	local imgs = {i_shard1, i_shard2, i_shard3}
	return imgs[math.random(1, #imgs)]
end