function drawBackground()
	lg.setBackgroundColor(25/255,30/255,60/255)
	
	--gen canvas
	if not gen then
		gen = true
		genBgCanvas()
	end
	
	--draw background
	lg.setColor(1,1,1)
	lg.draw(c_bg, border.x - c_bg:getWidth() / 2, border.y - c_bg:getHeight() / 2)
	
	--draw border
	setColor(14,18,35)
	love.graphics.rectangle('fill',border.x-border.width,border.y-border.height,border.width*2,border.height*2)
	
	local c = 0
	for i = border.x - border.width, border.x + border.width - 40, 40 do
		for j = border.y - border.height, border.y + border.height - 40, 40 do
			c = getDistance(i,j, player.x,player.y) / 40
			setColor(30,30,40 + c)
			lg.rectangle('fill', i,j, 40,40)
			setColor(20,20,25 + c)
			lg.rectangle('fill', i,j, 40 - 2,40 - 2)
		end
	end
	
	
	setColor(130,255,225)
	love.graphics.rectangle('line',border.x-border.width,border.y-border.height,border.width*2,border.height*2)
	
end

function genBgCanvas()

	--vars
	local cell = 40
	local w = 1280 * 4
	local h = 720 * 4
	local c_def = lg.getCanvas()
	
	--set canvas to new size
	c_bg = lg.newCanvas(w,h)
	
	--set canvas
	lg.scale(0.5)
	lg.setCanvas(c_bg)

	--flat bg
	setColor(25,30,60)
	lg.rectangle('fill',0,0, w,h)

	--lines
	setColor(55,65,90)
	for i=0,w,cell do
		lg.line(i, 0, i, h)
	end
	for j=0,h,cell do
		lg.line(0, j, w, j)
	end
	
	--dec
	setColor(55,65,90)
	for i=0,w,cell do
		for j=0,h,cell do
			if math.random(1,3) == 1 then
				lg.draw(getNewBgDecoration(), i + 20,j + 20, math.random(0,3) * math.pi/2, 0.5,0.5, 40,40)
			end
		end
	end
	
	lg.setCanvas(c_def)
end

function getNewBgDecoration()
	local decorations = {i_dec1,i_dec2,i_dec3,i_dec4,i_dec5}
	return decorations[math.random(1, #decorations)]
end