function drawEnemies()
	for i, e in pairs(enemies) do
		--freeze
		if e.freeze > 0 then
			setColor(130,255,225, 255*math.min(e.freeze/e.speed, 1))
			lg.draw(i_snowflake, e.x,e.y, e.freeze * 0.02, 0.17,0.17, i_snowflake:getWidth()/2,i_snowflake:getHeight()/2)
		end
	end

	local hitMult = 11
	for i, enemy in pairs(enemies) do
		--draw enemies
		if enemy.id == 1 then
			setColor(215,45,45)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(125,0,65)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 2 then
			setColor(20,160,205)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(15,55,155)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 3 then
			setColor(216,144,43)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(165,54,39)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 4 then
			if enemy.x < border.x + border.width and enemy.x > border.x - border.width and enemy.y < border.y + border.height and enemy.y > border.y - border.height then
				if enemy.iminentAttack then
					setColor(255,230,90,255/3)
				else
					setColor(255,230,90,255/5*enemy.timer*0.4)
				end
			else
				setColor(255,230,90,0)
			end
			love.graphics.line(0,enemy.y,1280,enemy.y)
			love.graphics.line(enemy.x,0,enemy.x,720)
			
			setColor(255,230,90)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(255,170,50)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 5 then
			setColor(230,80,120)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(130,10,100)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 6 then
			setColor(219,244,255)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(120,145,165)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 7 then
			setColor(180,35,110)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(65,0,65)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		elseif enemy.id == 8 then
			setColor(160,65,215)
			love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
			setColor(60,30,140)
			love.graphics.circle('fill',enemy.x,enemy.y,17+(enemy.hit*hitMult),40)
		end
		
		--enemy.hit stuff
		love.graphics.setBlendMode('add')
		setColor(255,255/2,255,180*enemy.hit)
		love.graphics.circle('fill',enemy.x,enemy.y,20+(enemy.hit*hitMult),40)
		love.graphics.setBlendMode('alpha')
		
	end
	
	lg.setCanvas(c_chromAbb)
	for i, e in pairs(enemies) do
		lg.setColor(1*e.hit, 0,0)
		lg.circle('fill',e.x,e.y,20+(e.hit*hitMult),40)
	end
	lg.setCanvas(c_screen)
	
	for i, e in pairs(enemies) do
		--glow
		setColor(e.color[1],e.color[2],e.color[3],255/3 + e.hit*100)
		drawEnemyGlow(e.x,e.y)
		
		--poison
		if e.poisonTimer > 0 then
			setColor(190,215,45, 255*0.25)
			lg.draw(i_skull, e.x,e.y, 0, 0.05,0.05, i_skull:getWidth()/2,i_skull:getHeight()/2)
		end
	end	
end

function drawEnemyGlow(x,y,s)
	s = s or 1
	lg.setBlendMode("add")
	lg.draw(i_fade, x,y, 0, 0.1*s,0.1*s, i_fade:getWidth()/2,i_fade:getHeight()/2)
	lg.setBlendMode("alpha")
end