function drawHUD()	
	--draw healthbar background
	setColor(65,0,65)
	love.graphics.rectangle('fill', 20+3,20-3,player.maxHealth*3+3,23)	--rects
	love.graphics.rectangle('fill', 20,20,player.maxHealth*3+6+3,20-3)
	love.graphics.circle('fill',20+3,20,3,10)	--cirlces
	love.graphics.circle('fill',20+3,20+(20-3),3,10)
	love.graphics.circle('fill',player.maxHealth*3+20+3+3,20,3,10)
	love.graphics.circle('fill',player.maxHealth*3+20+3+3,20+(20-3),3,10)
	--red bar
	if player.health > 0 then
		setColor(215 + (player.hurt * 75),45 + (player.hurt * 50),45)
		love.graphics.rectangle('fill', 20+3,20-3,player.health*3+3,23)	--rects
		love.graphics.rectangle('fill', 20,20,player.health*3+6+3,20-3)
		love.graphics.circle('fill',20+3,20,3,10)	--cirlces
		love.graphics.circle('fill',20+3,20+(20-3),3,10)
		love.graphics.circle('fill',player.health*3+20+3+3,20,3,10)
		love.graphics.circle('fill',player.health*3+20+3+3,20+(20-3),3,10)
	end
	--draw armor bar
	if player.armor > 1 then
		setColor(115,255,115)
		love.graphics.rectangle('fill', 20+3,20-3,player.armor*3+3,23)	--rects
		love.graphics.rectangle('fill', 20,20,player.armor*3+6+3,20-3)
		love.graphics.circle('fill',20+3,20,3,10)	--cirlces
		love.graphics.circle('fill',20+3,20+(20-3),3,10)
		love.graphics.circle('fill',player.armor*3+20+3+3,20,3,10)
		love.graphics.circle('fill',player.armor*3+20+3+3,20+(20-3),3,10)
	end
	
	--draw energy
	setColor(15,55,155)
	lg.rectangle('fill',20,45, 150*weapon.maxEnergy,14)
	setColor(65,215,215)
	lg.rectangle('fill',20,45, 150*weapon.energy,14)
	
	--draw wave text below energy
	if player.armor > 1 then
		setColor(115,255,115)
	else
		setColor(215,45,45)
	end
	love.graphics.setFont(f_eastlift)
	love.graphics.print('wave '.. wave.current, 20,65,0,1.5,1.5)
	
	--draw boss health
	local bossExists = false
	local totalHealth = 0
	local maxHealth = 0
	for i, e in pairs(enemies) do
		if e.id == 6 then 
			bossExists = true
			totalHealth = totalHealth + e.health
			maxHealth = maxHealth + e.maxHealth
		end
	end
	
	if bossExists then
		local w = 600
		setColor(85,100,125)
		lg.rectangle('fill', 1280/2-(w/2), 650, w, 25)
		setColor(165,190,205)
		lg.rectangle('fill', 1280/2-(w/2), 650, totalHealth/maxHealth * w, 25)
	end
		
	--draw cards
	if cards[1] then
		lg.setColor(0,0,0, 0.65)
		lg.rectangle('fill', 0,300,1280,200)
		lg.rectangle('fill', 0,220,1280,50)
	end
	for i, card in pairs(cards) do
		
		--draw card icons
		if audioController.combatVolume == 0 then
			local darkFactor = 0.65
			setColor(255*darkFactor,255*darkFactor,255*darkFactor)
		else
			setColor(255,255,255,255/3)
		end
		
		local img = i_cardReroll
		if card.id == 0 then
			img = i_cardReroll
		end
		if card.id == 1 then
			img = i_cardHealth
		end
		if card.id == 2 then
			img = i_cardSpeed
		end
		if card.id == 3 then
			img = i_cardDamage
		end
		if card.id == 4 then
			img = i_cardBorder
		end
		if card.id == 5 then
			img = i_cardFirerate
		end
		if card.id == 6 then
			img = i_cardFreeze
		end
		if card.id == 7 then
			img = i_cardPoison
		end
		if card.id == 8 then
			img = i_cardArmor
		end
		if card.id == 9 then
			img = i_cardEnergy
		end
		
		lg.draw(img,card.x+10 + (i_cardReroll:getWidth()/8),card.y+10 + (i_cardReroll:getHeight()/8), card.hoverScale - 1, 0.25*card.hoverScale,0.25*card.hoverScale, i_cardReroll:getWidth()/2,i_cardReroll:getHeight()/2)
	end
	
	--draw card levels
	for i, card in pairs(cards) do
		if card.id == 0 then
			currentCardLevel = "n/a"
		elseif card.id == 1 then
			currentCardLevel = cardLevel.health
		elseif card.id == 2 then
			currentCardLevel = cardLevel.speed
		elseif card.id == 3 then
			currentCardLevel = cardLevel.damage
		elseif card.id == 4 then
			currentCardLevel = cardLevel.border
		elseif card.id == 5 then
			currentCardLevel = cardLevel.firerate
		elseif card.id == 6 then
			currentCardLevel = cardLevel.freeze
		elseif card.id == 7 then
			currentCardLevel = cardLevel.poison
		elseif card.id == 8 then
			currentCardLevel = "n/a"
		elseif card.id == 9 then
			currentCardLevel = cardLevel.energy
		end
		love.graphics.setFont(f_eastliftmedium,25)
		setColor(255,230,90, 255*0.8)
		
		if card.id ~= 8 and card.id > 0 then
			love.graphics.print("Current Level: "..currentCardLevel,card.x-42.5,card.y-70)
		end
	end
	
	--draw card name
	for i, card in pairs(cards) do
		if card.hover then
			setColor(115,255,115)
			love.graphics.setFont(f_realityhyper)
			
			
			if card.id == 0 then
				love.graphics.print(" ",card.x,card.y+225)
			elseif card.id == 1 then
				love.graphics.print("+ maxhealth",card.x-15,card.y+225)
			elseif card.id == 2 then
				love.graphics.print("+ speed",card.x+23,card.y+225)
			elseif card.id == 3 then
				love.graphics.print("+ damage",card.x+8,card.y+225)
			elseif card.id == 4 then
				love.graphics.print("expand arena",card.x-35,card.y+225)
			elseif card.id == 5 then
				love.graphics.print("+ firerate",card.x+5,card.y+225)
			elseif card.id == 6 then
				love.graphics.print("+ freeze",card.x+8,card.y+225)
			elseif card.id == 7 then
				love.graphics.print("+ poison",card.x+22,card.y+225)
			elseif card.id == 8 then
				love.graphics.print("gain armor",card.x+10,card.y+225)
			elseif card.id == 9 then
				lg.print("+ max energy",card.x-25,card.y+225)
				lg.print("+ energy gain",card.x-25,card.y+255)
			end
		end
	end
	
	--draw wave text middle
	wave.alpha = wave.alpha - (250*hdt)
	love.graphics.setFont(f_eastliftbig)
	setColor(215,45,45,wave.alpha)
	if wave.current == 21 then
		love.graphics.printf('well done!', 0,720/2-45, 1280, "center", 0,1,1)
	elseif wave.current > 0 then
		love.graphics.printf('wave '.. wave.current, 0,720/2-45, 1280, "center", 0,1,1)
	end

	--draw volume info
	if love.keyboard.isDown('+','-') then
		love.graphics.setFont(f_realityhyper)
		setColor(255,239,90)
		love.graphics.print("Master volume: "..math.floor(options.volume*100),10,690)
	end
	
	
	--draw unlock text
	love.graphics.setFont(f_eastliftmedium)
	unlocks.textAlpha = unlocks.textAlpha - (255/2*hdt)
	local x = unlocks.textAlpha
	if x > 160 then
		x = 160
	end
	setColor(255,230,90,x)
	love.graphics.print("New character unlocked",1280/2-200,720/2-100)
	
	--draw tutorial
	local s = 0.25
	lg.setFont(f_realityhyperbig)
	setColor(130,157,178)
	if wave.alpha < 1975 then
		if wave.current == -3 then
			lg.printf("Use [W],[A],[S],[D] to move", 0,150, 1280 / s,"center", 0, s,s)
			lg.printf("Hold [LEFT MOUSE BUTTON] to shoot", 0,190, 1280 / s,"center", 0, s,s)
		end
		if wave.current == -2 then
			lg.printf("The red bar in the top-left is your health", 0,150, 1280 / s,"center", 0, s,s)
			lg.printf("It refills after each wave", 0,190, 1280 / s,"center", 0, s,s)
		end
		if wave.current == -1 then
			lg.printf("Hold [RIGHT MOUSE BUTTON] to use your special", 0,150, 1280 / s,"center", 0, s,s)
			lg.printf("Specials consume energy when used", 0,190, 1280 / s,"center", 0, s,s)
		end
		if wave.current == 0 then
			lg.printf("Deal damage to gain energy", 0,150, 1280 / s,"center", 0, s,s)
			lg.printf("The blue bar under your health displays your energy", 0,190, 1280 / s,"center", 0, s,s)
		end
	end
	
	--drawvignette
	lg.setBlendMode('add')
	setColor(255,255,255,0)
	if menu.character == 5 and player.health < (player.maxHealth/4) then
		setColor(215,45,45,255*0.45)
	elseif menu.character == 4 and player.armor > 1 then
		setColor(115,255,115, 255*0.45)
	end
	love.graphics.draw(i_vignette,0,0,0,1/i_vignette:getWidth()*1280,1/i_vignette:getHeight()*720)
	
	setColor(215 * 1.2,45 * 1.2,45 * 1.2,255*player.hurt*1.5)
	love.graphics.draw(i_vignette,0,0,0,1/i_vignette:getWidth()*1280,1/i_vignette:getHeight()*720)
	setColor(215 * 1.2,45 * 1.2,45 * 1.2,255*player.hurt*0.085)
	lg.rectangle('fill', 0,0, 1280,720)
	lg.setBlendMode('alpha')
	
	--draw gameover screen
	if player.health < 1 then
		gameover.redAlpha = gameover.redAlpha + (255/3*hdt)
		player.health = -99999
	end
	setColor(215*2.5-gameover.redAlpha,math.min(45,45*2.5-gameover.redAlpha), math.min(45,45*2.5-gameover.redAlpha),gameover.redAlpha)
	love.graphics.rectangle('fill',0,0,1280,720)
	setColor(215,45,45, gameover.redAlpha * 1.4 - 500)
	if wave.current == 21 then
		love.graphics.setFont(f_eastliftbig)
		love.graphics.printf("The End",0,720/2-45, 1280,"center")
	else
		love.graphics.setFont(f_eastliftbig)
		love.graphics.printf("GameOver",0,720/2-45, 1280,"center")
	end
	
	local s = 0.4
	lg.printf("press SPACE", 0,410, 1280 / s, "center", 0, s,s)
	
	--draw cursor
	setColor(230,230,230)
	love.graphics.circle('line',mouse.x,mouse.y,10,20)
end