function drawMenu()
	if inMenu then
		--menu background
		local mr = true	--check for background tiles
		for i, tile in pairs(menuTiles) do
			mr = false
		end
		
		if mr then	--generate tile grid
			
			local x1 = 0
			local y1 = 0
			
			while y1 < 720 + 40 do
				newTile = {x = x1, y = y1} table.insert(menuTiles,newTile)
				if x1 > 1280 + 40 then
					x1 = 0
					y1 = y1 + 40
				else
					x1 = x1 + 40
				end
			end
		end
		
		for i, tile in pairs(menuTiles) do
			--moveTiles
			local speed = 20
			if menu.view == "settings" then
				speed = -20
			end
			tile.x = (tile.x + speed*hdt) % (1280 + 40)
			tile.y = (tile.y + speed*hdt) % (720 + 40)
			
			--draw background tiles
			tile.decoration = tile.decoration or getNewMenuBgDecoration()
			tile.decRot = tile.decRot or math.random(0,3) * (math.pi / 2)
			
			if menu.view == "settings" then
				setColor(12,89,89)
			elseif menu.view == "main" then
				setColor(55,65,90)
			end
			love.graphics.rectangle('fill',tile.x - 40,tile.y - 40,40,40)	
			if menu.view == "settings" then
				setColor(13,45,58)
			elseif menu.view == "main" then
				setColor(25,30,60)
			end
			love.graphics.rectangle('fill',tile.x+1 - 40,tile.y+2 - 40,40-2,40-2)
			
			if tile.decoration ~= "nodec" then
				if menu.view == "settings" then
					setColor(12,89,89)
				elseif menu.view == "main" then
					setColor(55,65,90)
				end
				lg.draw(tile.decoration, tile.x + 20 - 40, tile.y + 20 - 40, tile.decRot, 0.5,0.5, 40,40)
			end
		end
		
		--decrease brightness
		lg.setBlendMode('subtract')
		lg.setColor(1,1,1,0.0)
		lg.rectangle('fill',0,0,1280,720)
		lg.setBlendMode('alpha')
		
		--buttons
		local shadowAlpha = 0.3
		local shadowOffset = 25
		for i, b in pairs(buttons) do
			if b.style == 'playerSelect' then
				--draw
				local c = 5
				
				if b.hover then
					setColor(85,100,125)
				else
					setColor(71,83,104)
				end
				lg.polygon('fill', b.x,b.y+c, b.x+c,b.y, b.x+b.w-c,b.y, b.x+b.w,b.y+c, b.x+b.w,b.y+b.h-c, b.x+b.w-c,b.y+b.h, b.x+c,b.y+b.h, b.x,b.y+b.h-c)
				
				if b.hover then
					setColor(120,145,163)
				else
					setColor(120,145,165)
				end
				
				local w = b.w - 15
				local h = w
				local x = b.x + b.w/2
				local y = b.y + b.h/2
				if b.icon == "right" then
					lg.polygon('fill', x - w/2,y - h/2, x + w/2,y, x - w/2,y + h/2)
				end
				if b.icon == "left" then
					lg.polygon('fill', x + w/2,y - h/2, x - w/2,y, x + w/2,y + h/2)
				end
				
			else
				--shadows
				lg.setColor(0,0,0,shadowAlpha)
				lg.polygon('fill', b.x,b.y + shadowOffset, b.x+b.w + shadowOffset,b.y + shadowOffset, b.x+(b.w - b.h*0.5) + shadowOffset,b.y+b.h + shadowOffset, b.x,b.y+b.h + shadowOffset)
				
				--draw
				if b.hover then
					setColor(85,100,125)
				else
					setColor(71,83,104)
				end
				lg.polygon('fill', b.x,b.y, b.x+b.w,b.y, b.x+(b.w - b.h*0.5),b.y+b.h, b.x,b.y+b.h)
				
				lg.setFont(f_realityhyperbig)
				
				if b.hover then
					setColor(120,145,163)
				else
					setColor(120,145,165)
				end
				lg.print(b.text, b.x + 20,b.y + 2, 0, b.h / f_eastliftbig:getHeight() * 1.1,b.h / f_eastliftbig:getHeight() * 1.1)
			end
		end
		
		--sliders
		for i, s in pairs(sliders) do
			--shadows
			local w = 10
			lg.setColor(0,0,0,shadowAlpha)
			
			lg.line(s.x + shadowOffset,s.y + s.h/2 + shadowOffset, s.x+s.w + shadowOffset, s.y + s.h/2 + shadowOffset)
			lg.rectangle('fill', s.x + s.setting*s.w - w/2 + shadowOffset, s.y + shadowOffset, w, s.h)
			
			lg.print(s.text, s.x + shadowOffset,s.y - s.h - 5 + shadowOffset, 0, s.h / f_eastliftbig:getHeight() * 1.1,s.h / f_eastliftbig:getHeight() * 1.1)
			lg.print((math.floor(s.setting*10 + 0.5)/10), s.x + s.w + 20 + shadowOffset,s.y + shadowOffset, 0, s.h / f_eastliftbig:getHeight() * 1.1,s.h / f_eastliftbig:getHeight() * 1.1)
			
			--draw
			if s.hover then
				setColor(85,100,125)
			else
				setColor(71,83,104)
			end
			lg.line(s.x,s.y + s.h/2, s.x+s.w, s.y + s.h/2)
			lg.rectangle('fill', s.x + s.setting*s.w - w/2, s.y, w, s.h)
			
			lg.setFont(f_realityhyperbig)
			
			if s.hover then
				setColor(130,157,178)
			else
				setColor(120,145,165)
			end
			lg.print(s.text, s.x,s.y - s.h - 5, 0, s.h / f_eastliftbig:getHeight() * 1.1,s.h / f_eastliftbig:getHeight() * 1.1)
			lg.print((math.floor(s.setting*10 + 0.5)/10), s.x + s.w + 20,s.y, 0, s.h / f_eastliftbig:getHeight() * 1.1,s.h / f_eastliftbig:getHeight() * 1.1)
		end
		
		--draw selected player
		if menu.view == "main" then
			local x,y,s = 995,150,4
			if menu.character == 0 or menu.character == 3 and unlocks.smuggler == 1 or menu.character == 4 and unlocks.blacksmith == 1 or menu.character == 5 and unlocks.berserker == 1 or menu.character == 6 and unlocks.gambler == 1 then
				drawSelectedPlayer(x,y,s)
			else
				setColor(170,20,60)
				lg.draw(i_lock, x,y,0, 0.15*s,0.15*s, i_lock:getWidth()/2,i_lock:getHeight()/2)
			end
			
			--draw selected player text
			drawCharacterInfo(x,y,1)
		end
		
		
		--draw cursor
		setColor(230,230,230)
		love.graphics.circle('line',mouse.x,mouse.y,10,20)
	end
end

function drawCharacterInfo(x,y,s)
	s = s or 1

	--set text
	local unlockText = ''
	local nameText = 'Name: '
	local passiveText = '\n\nPassive: '
	local specialText = '\n\nActive: '
	local difficultyText = '\n\nDifficulty: '
	local text = ""
	
	if menu.character == 0 then
		nameText = nameText..'Knight'
		passiveText = passiveText..'Health slowly regenerates when close to death'
		specialText = specialText..'Energy beam'
		difficultyText = difficultyText..'Normal'
	end
	if menu.character == 3 then
		nameText = nameText..'Smuggler'
		passiveText = passiveText..'Picks between 3 upgrade cards, deals extra damage up close'
		specialText = specialText..'Shock wave'
		unlockText = unlockText..'Beat wave 10 with Knight'
		difficultyText = difficultyText..'Hard'
	end
	if menu.character == 4 then
		nameText = nameText..'Blacksmith'
		passiveText = passiveText..'Gains armor every wave, deals more damage when armor is equiped'
		specialText = specialText..'Fortify'
		unlockText = unlockText..'Beat wave 10 with Smuggler\n\nor\n\nBeat wave 20 with Knight'
		difficultyText = difficultyText..'Hard'
	end
	if menu.character == 5 then
		nameText = nameText..'Berserker'
		passiveText = passiveText..'improved firerate and speed at low health'
		specialText = specialText..'Energy blast'
		unlockText = unlockText..'Beat wave 10 with Blacksmith\n\nor\n\nBeat wave 20 with Smuggler'
		difficultyText = difficultyText..'Very Hard'
	end
	if menu.character == 6 then
		nameText = nameText..'Gambler'
		passiveText = passiveText..'can reroll cards'
		specialText = specialText..'Deploy turret'
		unlockText = unlockText..'Beat wave 10 with Berserker\n\nor\n\nBeat wave 20 with Blacksmith'
		difficultyText = difficultyText..'Insane'
	end
	
	
	--concat text
	if menu.character == 0 or menu.character == 3 and unlocks.smuggler == 1 or menu.character == 4 and unlocks.blacksmith == 1 or menu.character == 5 and unlocks.berserker == 1 or menu.character == 6 and unlocks.gambler == 1 then
		text = nameText..passiveText..specialText..difficultyText
	else
		text = unlockText
	end
	
	--draw text
	lg.setFont(f_realityhyperbig)
	
	setColor(120,145,165)
	lg.printf(text, x - 220,y + 100, 1695, 'left', 0, 0.3 * s,0.3 * s)
end

function drawSelectedPlayer(x,y,s)
	setColor(115,255,115)
	love.graphics.circle('line',x,y,20*s,60*s)
	
	lg.setLineWidth(3)
	if menu.character == 1 then
		setColor(115,255,115)
		love.graphics.line(x-20*s,y,x+20*s,y)
	elseif menu.character == 2 then
		setColor(115,255,115)
		love.graphics.line(x,y-20*s,x,y+20*s)
	elseif menu.character == 3 then
		setColor(115,255,115)
		love.graphics.circle('line',x,y,20/3*2*s,40*s)
	elseif menu.character == 4 then
		setColor(115,255,115)
		love.graphics.line(x-10*s,y-10*s, x+10*s,y-10*s, x+10*s,y+5*s, x,y+14*s, x-10*s,y+5*s, x-10*s,y-10*s)
	elseif menu.character == 5 then
		setColor(115,255,115)
		love.graphics.line(x,y-17*s, x+10*s,y, x,y+17*s, x-10*s,y, x,y-17*s)
	elseif menu.character == 6 then
		setColor(115,255,115)
		love.graphics.line(x-10*s,y-12.5*s, x+10*s,y-12.5*s, x+15*s,y-2.5*s, x,y+15*s, x-15*s,y-2.5*s, x-10*s,y-12.5*s)
		love.graphics.line(x-15*s,y-2.5*s, x+15*s,y-2.5*s)
		love.graphics.line(x-2.5*s,y-12.5*s, x-8*s,y-2.5*s, x,y+15*s)
		love.graphics.line(x+2.5*s,y-12.5*s, x+8*s,y-2.5*s, x,y+15*s)
	end
	
	setColor(115,255,115,255/3)
	lg.setBlendMode("add")
	lg.draw(i_fade, x,y, 0, 0.1,0.1, i_fade:getWidth()/2,i_fade:getHeight()/2)
	lg.setBlendMode("alpha")
end

function getNewMenuBgDecoration()
	local decorations = {i_dec1,i_dec2,i_dec3,i_dec4,i_dec5}
	if math.random(1,3) == 1 then
		return decorations[math.random(1, #decorations)]
	else
		return "nodec"
	end
end