function applyScreenShaders()
	lg.scale(0.5,0.5)
	lg.setColor(1,1,1)
	local defaultCanvas = lg.getCanvas()
	
	--chromatic abberation
	sh_chromAbb:send('abbMap', c_chromAbb)
	
	lg.setCanvas(c_shader)
	lg.setShader(sh_chromAbb)
	lg.clear()
	
	lg.draw(defaultCanvas)
	
	lg.setCanvas(defaultCanvas)
	lg.clear()
	lg.setShader()
	lg.draw(c_shader)
	
	lg.setCanvas(c_chromAbb)
	lg.clear()
	
	--transform
	sh_transform:send('scale', screen.scale.x)
	sh_transform:send('rot', (math.random()-.5)*screen.rotation)
	sh_transform:send('ox', (math.random()-.5)*screen.shaking)
	sh_transform:send('oy', (math.random()-.5)*screen.shaking)
	
	lg.setCanvas(c_shader)
	lg.setShader(sh_transform)
	lg.clear()
		
	lg.draw(defaultCanvas)
	
	lg.setCanvas(defaultCanvas)
	lg.clear()
	lg.setShader()
	lg.draw(c_shader)
	
	--shatter
	sh_shatter:send('glitchMap', c_glitch)
	sh_shatter:send('intensity', options.shatterIntensity)
	
	lg.setCanvas(c_shader)
	lg.setShader(sh_shatter)
	lg.clear()
	
	lg.draw(defaultCanvas)
	
	lg.setCanvas(defaultCanvas)
	lg.setShader()
	lg.clear()
	lg.draw(c_shader)
	
	--glow
	local sf = player.health / player.maxHealth * 3
	if player.health <= 0 then
		sf = gameover.redAlpha * 0.002 - 0.35
	end
	sh_bloom:send('saturationFactor', math.max(math.min(sf, 1), 0.15) )
	
	lg.setCanvas(c_shader)
	lg.setShader(sh_bloom)
	lg.clear()
		
	lg.draw(defaultCanvas)
	
	lg.setCanvas(defaultCanvas)
	lg.clear()
	lg.setShader()
	lg.draw(c_shader)
	
	lg.setCanvas(c_bloom)
	lg.clear()
	
	--bend
	lg.setCanvas(c_shader)
	lg.setShader(sh_bend)
	lg.clear()
	
	lg.draw(defaultCanvas)
	
	lg.setCanvas(defaultCanvas)
	lg.clear()
	lg.setShader()
	lg.draw(c_shader)
	
	--draw shader
	lg.setShader()
	lg.setCanvas(c_screen)
	lg.clear()
	lg.draw(c_shader)
	lg.draw(c_shader,defaultCanvas:getWidth()/2,defaultCanvas:getHeight()/2, 0, 1,1, defaultCanvas:getWidth()/2,defaultCanvas:getHeight()/2)
end

sh_bend = lg.newShader[[
    vec4 effect( vec4 color, Image texture, vec2 tc, vec2 sc ){
		
		number f = -0.2;
		number x = tc.x + (f * (0.5 - tc.x) * pow(tc.y - 0.5,2));
		number y = tc.y + (f * (0.5 - tc.y) * pow(tc.x - 0.5,2));
		
		if (x > 1 || x < 0 || y > 1 || y < 0) {
			return vec4(0,0,0,1);
		} else {
			return Texel(texture,vec2(x,y));
		}

		
    }
]]

sh_chromAbb = lg.newShader[[
	extern Image abbMap;
	
    vec4 effect( vec4 color, Image texture, vec2 tc, vec2 sc ){
		
		number f = 0.0035 * distance(tc, vec2(0.5,0.5));
		vec4 mapValue = Texel(abbMap, tc);
		
		if(mapValue.r > 0) {
			f = 0.011 * mapValue.r;
		}
		
		return vec4(Texel(texture,tc+f).r, Texel(texture,tc).g, Texel(texture,tc-f).b,1);
		
    }
]]

sh_bloom = lg.newShader[[
	extern float saturationFactor;

	vec4 effect( vec4 color, Image texture, vec2 tc, vec2 sc ){
		
		//scan lines
		number distW = 0.0009*1.5;
		number distH = 0.0016*1.5;
		number power = 0.9;
		if(mod(floor(tc.y*360), 2) == 0) {
			power = 0.8 ;
		}
			
		vec4 pixel = Texel(texture,tc);
		
		//glow
		pixel += Texel(texture,vec2(tc.x + distW,tc.y)) * 0.1 * power;
		pixel += Texel(texture,vec2(tc.x - distW,tc.y)) * 0.1 * power;
		pixel += Texel(texture,vec2(tc.x,tc.y + distH)) * 0.1 * power;
		pixel += Texel(texture,vec2(tc.x,tc.y - distH)) * 0.1 * power;
		
		pixel += Texel(texture,vec2(tc.x + distW,tc.y + distH)) * 0.07 * power;
		pixel += Texel(texture,vec2(tc.x - distW,tc.y + distH)) * 0.07 * power;
		pixel += Texel(texture,vec2(tc.x + distW,tc.y - distH)) * 0.07 * power;
		pixel += Texel(texture,vec2(tc.x - distW,tc.y - distH)) * 0.07 * power;
		
		pixel += Texel(texture,vec2(tc.x + distW * 2,tc.y)) * 0.04 * power;
		pixel += Texel(texture,vec2(tc.x - distW * 2,tc.y)) * 0.04 * power;
		pixel += Texel(texture,vec2(tc.x,tc.y + distH * 2)) * 0.04 * power;
		pixel += Texel(texture,vec2(tc.x,tc.y - distH * 2)) * 0.04 * power;
		
		pixel += Texel(texture,vec2(tc.x + distW * 1.5,tc.y + distH * 1.5)) * 0.025 * power;
		pixel += Texel(texture,vec2(tc.x - distW * 1.5,tc.y + distH * 1.5)) * 0.025 * power;
		pixel += Texel(texture,vec2(tc.x + distW * 1.5,tc.y - distH * 1.5)) * 0.025 * power;
		pixel += Texel(texture,vec2(tc.x - distW * 1.5,tc.y - distH * 1.5)) * 0.025 * power;
		
		//saturation
		number average = (pixel.r + pixel.g + pixel.b) / 3;
		pixel.r = (pixel.r * saturationFactor) + (average * (1 - saturationFactor));
		pixel.g = (pixel.g * saturationFactor) + (average * (1 - saturationFactor));
		pixel.b = (pixel.b * saturationFactor) + (average * (1 - saturationFactor));
		
		//cap brightness
		pixel.r = min(pixel.r, 0.9);
		pixel.g = min(pixel.g, 0.9);
		pixel.b = min(pixel.b, 0.9);
		
		//return 
		return pixel;
		
	
	}
]]

sh_transform = lg.newShader[[
	extern float scale;
	extern float rot;
	extern float ox;
	extern float oy;
	
	vec4 effect( vec4 color, Image texture, vec2 tc, vec2 sc ){
		
		number dist = distance(tc, vec2(0.5, 0.5));
		number a = atan(tc.y - 0.5,tc.x - 0.5) + rot;
		number x = cos(a) * dist / scale + 0.5 + ox * 0.0008;
		number y = sin(a) * dist / scale + 0.5 + oy * 0.0008;
		
		vec4 pixel = (Texel(texture,vec2(x, y)));
		
		return pixel;
	}
]]

sh_shatter = lg.newShader[[
	extern Image glitchMap;
	extern float intensity;
	
    vec4 effect( vec4 color, Image texture, vec2 tc, vec2 sc ){
		
		number f = 0.3 * intensity;
		vec4 mapValue = Texel(glitchMap, tc);
		vec4 pixel = Texel(texture, vec2(tc.x + ((mapValue.r-0.5) * f), tc.y + ((mapValue.g-0.5) * f)));
		
		return pixel;
		
    }
]]