function loadSpecials()
	function sa_piercingShot()
		if not inMenu then
			local timeBetweenShots = 1.1
			weapon.pierceTimer = weapon.pierceTimer or 0
			weapon.pierceTimer = math.min(weapon.pierceTimer + hdt, timeBetweenShots)
			
			if weapon.pierceTimer >= timeBetweenShots and lm.isDown(2) and weapon.energy > 0.15 then
				weapon.pierceTimer = weapon.pierceTimer - timeBetweenShots 
				weapon.energy = weapon.energy - 0.15
			
				screen:zoom(0.97)
				screen:shake(60)
				a_shoot:setPitch(math.random(70,80)/100)
				la.play(a_shoot:clone())
				local angle = math.angle(player.x,player.y, mouse.x,mouse.y)
				local dist = 12
				for i=0,25 do
					local sAngle = angle + math.rad(math.random(-10,10))
					spark(1, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.15,1, "blue", 160)
					spark(4, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.15,1, {65,215,215}, 1.05)
					newBullet = {x = player.x + math.cos(angle)*dist, y = player.y + math.sin(angle)*dist, xdir = math.cos(sAngle), ydir = math.sin(sAngle), speed = 2000, damage = weapon.damage, friendly = true, color = "blue", noEnergy = true} table.insert(bullets,newBullet)
				end
			end
		end
	end
	
	function sa_beam()
		if not inMenu then
			weapon.beamTimer = weapon.beamTimer or 0
			local timeBetweenShots = weapon.maxTimer / 1.75
			weapon.beamTimer = math.min(weapon.beamTimer + hdt, timeBetweenShots)
			local angle = math.angle(player.x,player.y, mouse.x,mouse.y)
			local dist = 12
			
			if lm.isDown(2) and weapon.beamTimer >= timeBetweenShots and weapon.energy > 0.015 then
				weapon.beamTimer = weapon.beamTimer - timeBetweenShots
				weapon.energy = weapon.energy - 0.015
				
				spark(1, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.2,1, "blue", 160)
				spark(4, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.2,1, {65,215,215}, 1.05)
				newBullet = {x = player.x + math.cos(angle)*dist, y = player.y + math.sin(angle)*dist, xdir = xd, ydir = yd, speed = 1800, damage = weapon.damage*1.4, friendly = true, color = "blue", noEnergy = true} table.insert(bullets,newBullet)
				a_shoot:setPitch(math.random(140,150)/100)
				la.play(a_shoot:clone())
					
				screen:shake(30)
			end
		end
	end
	
	function sa_stim()
		local interval = 1/15
		weapon.stimTimer = weapon.stimTimer or 0
		weapon.stimTimer = math.min(weapon.stimTimer + hdt, interval)
		
		
	
		if not inMenu then
			if lm.isDown(2) and weapon.energy > 0 then
				weapon.energy = math.max(weapon.energy - (0.25*hdt), 0)
				player.armor = math.min(player.armor + (8*hdt), player.maxHealth)
				player.speed = player.defSpeed * 0.3
				
				if weapon.stimTimer >= interval then
					weapon.stimTimer = weapon.stimTimer - interval
					spark(1, player.x,player.y,0,1,0.6,1, "blue", 10)
					spark(4, player.x,player.y,0,1,0.6,1, {65,215,215}, 0.3)
				end
			end
		end
	end
	
	function sa_clear()
		if not inMenu then
			local timeBetweenShots = 1.5
			weapon.clearTimer = weapon.clearTimer or 0
			weapon.clearTimer = math.min(weapon.clearTimer + hdt, timeBetweenShots)
			
			if weapon.clearTimer >= timeBetweenShots and lm.isDown(2) and weapon.energy > 0.5 then
				weapon.clearTimer = weapon.clearTimer - timeBetweenShots 
				weapon.energy = weapon.energy - 0.5
			
				screen:zoom(0.97)
				screen:shake(60)
				local dist = 12
				for angle=0,math.rad(360),math.rad(6) do
					local sAngle = angle + math.rad(math.random(-10,10))
					spark(1, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.15,1, "blue", 160)
					spark(4, player.x + math.cos(angle)*dist,player.y + math.sin(angle)*dist ,0,1,0.15,1, {65,215,215}, 1.05)
					newBullet = {x = player.x + math.cos(angle)*dist, y = player.y + math.sin(angle)*dist, xdir = math.cos(sAngle), ydir = math.sin(sAngle), speed = 2000, damage = weapon.damage * 2, friendly = true, color = "blue", noEnergy = true} table.insert(bullets,newBullet)
					a_shoot:setPitch(math.random(140,150)/100)
					la.play(a_shoot:clone())
					
					screen:shake(10)
				end
			end
		end
	end
	
	function sa_turret()
		if not inMenu then
			local energyCon = 0.75
			
			if specialPressed and weapon.energy >= energyCon then
				specialPressed = false
				weapon.energy = weapon.energy - energyCon
				
				table.insert(turrets, {x=player.x,y=player.y})
			end
			
		end
	end
end

function updateSpecials()
	--turrets
	for i, t in pairs(turrets) do
		--find closest enemy
		local angle = 0
		local eDist = 10^9
		for j, e in pairs(enemies) do
			if getDistance(e.x,e.y, t.x,t.y) < eDist and e.x < border.x + border.width and e.x > border.x - border.width and e.y < border.y + border.height and e.y > border.y - border.height then
				eDist = getDistance(e.x,e.y, t.x,t.y)
				angle = math.angle(t.x,t.y, e.x,e.y)
			end
		end
		
		--shoot
		local maxTimer = weapon.maxTimer * 1.45
		
		t.timer = t.timer or 0
		if angle ~= 0 then
			t.timer = t.timer + hdt
		end
		
		if t.timer >= maxTimer and angle ~= 0 then
			t.timer = t.timer - maxTimer
			local dist = 12
			spark(1, t.x + math.cos(angle)*dist,t.y + math.sin(angle)*dist ,0,1,0.15,1, "blue", 160)
			spark(4, t.x + math.cos(angle)*dist,t.y + math.sin(angle)*dist ,0,1,0.15,1, {65,215,215}, 1.05)
			newBullet = {x = t.x + math.cos(angle)*dist, y = t.y + math.sin(angle)*dist, xdir = math.cos(angle), ydir = math.sin(angle), speed = 1800, damage = weapon.damage * 0.45, friendly = true, color = "blue", noEnergy = true} table.insert(bullets,newBullet)
				
		end
		
		--die
		if t.deathTimer then
			t.deathTimer = t.deathTimer - (1.75*hdt)
			if t.deathTimer <= 0 then 
				table.remove(turrets, i)
			end
		end
		
	end
end

function love.mousepressed( x, y, button, istouch, presses )
	if button == 1 then
		primaryPressed = true
	end
	if button == 2 then
		specialPressed = true
	end
end