lg = love.graphics
la = love.audio
lk = love.keyboard
lt = love.timer
lm = love.mouse
lf = love.filesystem


inMenu = true

player = {x = 1280/2, y = 720/2, speed = 250, defSpeed = 250, xdir = 0, ydir = 0, health = 100, maxHealth = 100, previousHealth = 100, armor = 0, jumpDist = 250, jumpCoolDown = 0.5, hurt = 0, enemyFerocity = 1}
weapon = {equiped = 0, timer = 0, maxTimer = 0.2, damage = 15, speed = 1800, poisonTime = 0, freeze = 0, special = function() end, energy = 1,maxEnergy=1,energyGain=1}
border = {x = 1280/2, y = 720/2, width = 440, height = 240}
col = {blockUp = false, blockDown = false, blockLeft = false, blockRight = false}
wave = {current = 1, active = true, alpha = 1000, timer = 5, displayCards = false, maxEnemies = 5}
cardRandom = {first = 1, second = 1}
cardLevel = {speed = 0, health = 0, damage = 0, firerate = 0, armor = 0, poison = 0, border = 0, freeze = 0, energy = 0}
menu = {selected = 1, lightX = 0, lightY = 450, isDown = false, sx = 1280/2, character = 0, charX = (1280/2-562.5+25)+75, charY = 450-160/2-5, alphaStats = 0, view = "main", glitchTimer = 0}
mouse = {adjustX = 0, adjustY = 0}
characterInfo = {name = "n/a",damage = "n/a",speed = "n/a",firerate = "n/a", special = "n/a"}
unlocks = {smuggler = false, blacksmith = false, berserker = false, gambler = false, started = false, tutorial = false, textAlpha = 0, killCount = 0, wavesCompleted = {0,0,0,0,0}}
audioController = {combatVolume = 0, cardVolume = 0, menuVolume = 0.5}
audioRandom = {combat = 1, change = false, pCombat = 1, boss = false}
options = {fullscreen = false, volume = 0.5, showFps = false, press = false, shakeIntensity = 0.5, zoomIntensity = 0.5, shatterIntensity = 0.5, hdtMult = 1}
gameover = {redAlpha = 0}
particles = {}
cards = {}
enemies = {}
bullets = {}
bgTiles = {}
menuTiles = {}
turrets = {}
buttons = {}
sliders = {}
summonList = {}
glitchObjects = {}


function love.load(arg)
	require('bin/functions')
	require('bin/input')
	require('bin/enemies')
	require('bin/bullets')
	require('bin/bgtiles')
	require('bin/player')
	require('bin/cards')
	require('bin/menu')
	require('bin/unlocks')
	require('bin/particles')
	require('bin/wavecontroller')
	require('bin/audiocontroller')
	require('bin/specialAttacks')
	require('bin/render/drawplayer')
	require('bin/render/drawenemies')
	require('bin/render/drawbullets')
	require('bin/render/drawhud')
	require('bin/render/drawbackground')
	require('bin/render/drawmenu')
	require('bin/render/drawparticles')
	require('bin/render/shaders')
	screen = require('libs/shack')
	
	loadFunctions()
	loadSpecials()
	love.mouse.setVisible(false)
	
	--lg.setDefaultFilter("nearest","nearest")
	
	--get imgs
	i_lines = love.graphics.newImage('assets/overlays/lines.png')
	i_vignette = love.graphics.newImage('assets/overlays/vignette.png')
	i_cardHealth = love.graphics.newImage('assets/cards/health.png')
	i_cardSpeed = love.graphics.newImage('assets/cards/speed.png')
	i_cardDamage = love.graphics.newImage('assets/cards/damage.png')
	i_cardBorder = love.graphics.newImage('assets/cards/border.png')
	i_cardFirerate = love.graphics.newImage('assets/cards/firerate.png')
	i_cardPoison = love.graphics.newImage('assets/cards/poison.png')
	i_cardFreeze = love.graphics.newImage('assets/cards/freeze.png')
	i_cardArmor = love.graphics.newImage('assets/cards/armor.png')
	i_cardEnergy = love.graphics.newImage('assets/cards/energy.png')
	i_cardReroll = love.graphics.newImage('assets/cards/reroll.png')
	i_window = love.graphics.newImage('assets/menu/window.png')
	i_fullscreen = love.graphics.newImage('assets/menu/fullscreen.png')
	i_skull = love.graphics.newImage('assets/skull.png')
	i_snowflake = love.graphics.newImage('assets/snowflake.png')
	i_bullet = love.graphics.newImage('assets/gameobjects/bullet.png')
	i_bulletFade = love.graphics.newImage('assets/gameobjects/bulletFade.png')
	i_fade = love.graphics.newImage('assets/fade.png')
	i_lock = lg.newImage('assets/menu/lock.png')
	i_dec1 = love.graphics.newImage('assets/bgDecs/1.png')
	i_dec2 = love.graphics.newImage('assets/bgDecs/2.png')
	i_dec3 = love.graphics.newImage('assets/bgDecs/3.png')
	i_dec4 = love.graphics.newImage('assets/bgDecs/4.png')
	i_dec5 = love.graphics.newImage('assets/bgDecs/5.png')
	i_shard1 = love.graphics.newImage('assets/shards/1.png')
	i_shard2 = love.graphics.newImage('assets/shards/2.png')
	i_shard3 = love.graphics.newImage('assets/shards/3.png')
	
	
	--get fonts
	f_eastlift = love.graphics.newFont('assets/fonts/eastlift.ttf')
	f_eastliftmedium = love.graphics.newFont('assets/fonts/eastlift.ttf',30)
	f_eastliftbig = love.graphics.newFont('assets/fonts/eastlift.ttf',90)
	f_realityhyper = love.graphics.newFont('assets/fonts/realityhyper.ttf', 30)
	f_realityhyperbig = love.graphics.newFont('assets/fonts/realityhyper.ttf', 90)
	
	--get audio
	a_shoot = love.audio.newSource('assets/audio/shoot.wav', 'static')
	a_hit = love.audio.newSource('assets/audio/hit.mp3', 'static')
	a_hit2 = love.audio.newSource('assets/audio/hit2.wav', 'static')
	a_enemyDeath = love.audio.newSource('assets/audio/enemyDeath.wav', 'static')
	a_cardselect = love.audio.newSource('assets/audio/cardselect.wav', 'static')
	a_carduse = love.audio.newSource('assets/audio/carduse.wav', 'static')
	a_select = love.audio.newSource('assets/audio/select.wav', 'static')
	a_start = love.audio.newSource('assets/audio/start.wav', 'static')
	a_back = love.audio.newSource('assets/audio/back.wav', 'static')
	a_musicCombat = love.audio.newSource('assets/audio/musiccombat.mp3', 'static')
	a_musicCombat1 = love.audio.newSource('assets/audio/musiccombat.mp3', 'static')
	a_musicCombat2 = love.audio.newSource('assets/audio/musiccombat2.mp3', 'static')
	a_musicCombat3 = love.audio.newSource('assets/audio/musiccombat3.mp3', 'static')
	a_musicCombat4 = love.audio.newSource('assets/audio/musiccombat4.mp3', 'static')
	a_musicCombat5 = love.audio.newSource('assets/audio/musiccombat5.mp3', 'static')
	a_musicCombat6 = love.audio.newSource('assets/audio/musiccombat6.mp3', 'static')
	a_musicMenu = la.newSource('assets/audio/musicmenu.mp3', 'static')
	
	--canvases
	c_screen = lg.newCanvas(1280*2,720*2)
	c_shader = lg.newCanvas(1280*2,720*2)
	c_chromAbb = lg.newCanvas(1280*2,720*2)
	c_glitch = lg.newCanvas(1280*2,720*2)
	c_bg = lg.newCanvas(1280*2,720*2)
	
	--start music
	a_musicMenu:setVolume(audioController.menuVolume)
	la.play(a_musicMenu)
	
	deb = {}
end

function love.update(dt)
	screen:update(dt)

	if player.health < 0 then
		player.health = 0
	end
	
	updateCardRandom()
	updateAudioRandom()
	
	hdt = dt * options.hdtMult
	mouse.x = love.mouse.getX() - mouse.adjustX
	mouse.y = love.mouse.getY() - mouse.adjustY
	
	
	player.previousHealth = player.health
	
	--update requierd functions
	updateAudioController()
	updateParticles()
	updateUnlocks()
	updateMenu()
	updateWaveController()
	updateSpecials()
	updatePlayer()
	updateInput()
	updateBullets()
	updateBGTiles()
	updatePlayer()
	updateCards()
	updateEnemies()
	
	--set presed values to false
	specialPressed = false
	primaryPressed = false
end

function love.draw(dt)
	lg.setCanvas(c_screen)

	if mouse.x == nil or mouse.y == nil then
		mouse.x = 0
		mouse.y = 0
	end
	
	love.graphics.scale(2,2)
	
	drawBackground()
	drawBullets()
	drawPlayer()
	drawEnemies()
	drawParticles()
	drawHUD()
	drawMenu()
	applyScreenShaders()
	

	
	if options.showFps then
		love.graphics.setColor(0,0,255)
		love.graphics.setFont(f_realityhyper)
		love.graphics.print("FPS "..love.timer.getFPS(),1150,10)
		
		lg.setColor(1,0,1)
		for i = 2, #deb do
			lg.print(math.floor((deb[i] - deb[i - 1]) * 10000).." "..i, 40,10 + i * 30, 0)
		end
	end
	
	love.graphics.scale(lg.getWidth()/1280/2,lg.getHeight()/720/2)
	
	screen:apply()
	
	lg.setCanvas()
	lg.setColor(1,1,1)
	lg.draw(c_screen)
end